--Welcome. I've written this code myself and heavily improved and fixed it with the help of Angelo234! Lots of Thanks to him!! I've marked sections of his code.
--Anyways, you're probably here because you want to add you own music, which is fair enough, the Beam music isn't all thaat exiting
--There are instructions in form of notes all over the file. If you experience any issues, feel free to contact me under Inn0centJok3r on BeamNG.com 
--I hope the notes are helpful enough to allow you to get your stuff working. Have a nice day!

--Please read all notes.

local M = {}

local sfx_table = {} --For caching the played music

local songName = "Radio Off"

local songLimit = 8		--Set your new limit for the max amount of songs in a playlist here!
local listLimit = 2		--Set your new limit for the max amount of playlists here!

local volume = 4
local song = 0
local list = 1
local timer = 0
local musicList = "Default Music"
local author = "Unknown"
local play_song_dir = nil
local inputBlock = false
local need_to_create_sfx = false
local current_sfx_playing = nil
local song_dir = nil

local function playList()

	if list == 1 then
	musicList = "Default Music"
	
		if song == 0 then 
			songName = "How did you do this?"
			play_song_dir  = nil
			author = "Unknown"

		elseif song == 1 then
			songName = "Very Bassy Music"
			play_song_dir  = "art/sound/music/Legran_Music_interior"
			author = "MGR '99"
			
		elseif song == 2 then
			songName = "Drip Fountain"
			play_song_dir  = "art/sound/music/drip_fountain"
			author = "Gabester and CaptainZoll"
			
		elseif song == 3 then
			songName = "Lightrunner Theme Loop"
			play_song_dir  = "event:>Music>synthwave"
			author = "Mark 'TDK' Knight"

		elseif song == 4 then
			songName = "lonle (Credits Theme)"
			play_song_dir  = "ui/modules/credits/lonle.ogg"
			author = "BeamNG"

		elseif song == 5 then
			songName = "Piano"
			play_song_dir  = "event:>Special>piano_music"
			author = "Claude Debussy"

		elseif song == 6 then
			songName = "Dicta"
			play_song_dir  = "art/sound/music/dicta"
			author = "Unknown"

		elseif song == 7 then
			songName = "Merry Christmas Jingle"
			play_song_dir  = "art/sounds/mod_winter/Merry_Christmas_Jingle_Filtered_01.protected.ogg"
			author = "Unknown"

		elseif song == 8 then
			songName = "Deck The Halls Bells"
			play_song_dir  = "art/sounds/mod_winter/Deck_the_Halls_Bells_Filtered.protected.ogg"
			author = "Unknown"
		end

	elseif list == 2 then
	musicList = "Custom Music (insert your own music here)" --Feel free to change the playlist name. To add more lists, you can just copy paste this one here to the spot marked --X and then change listLimit=2 to 3 or whichever	
															--... amount of lists that you want to add.
		if song == 0 then 
			songName = "How did you do this?"
			play_song_dir  = nil
			author = "Unknown"

		elseif song == 1 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 2 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 3 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 4 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 5 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 6 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"

		elseif song == 7 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"
		elseif song == 8 then
			songName = "Your Song Name Here"
			--play_song_dir  = "art/sound/music/YOUR FILE NAME HERE"
			author = "Unknown"
		end

		--X new playlists -underneath- this point here! Make sure to NOT place anything UNDER the "end"
		
	end
end
--No need to change anything below here. Unless you know what you're doing

--Code by Angelo234 start

local function loadSong(song_dir)
    --If SFX source is not cached (has never been played), then create SFX source
    if not sfx_table[song_dir] then
        sfx_table[song_dir] = obj:createSFXSource(song_dir, "AudioDefaultLoop3D", "", 1)
        return true
    end
  
    return false
end

local function playSong(song_dir)
    --Stop current music
    if current_sfx_playing then
		obj:setVolumePitch(current_sfx_playing, 0, 1)
        obj:stopSFX(current_sfx_playing)
    end
  
    --Play new song
    local sfx_to_play = sfx_table[song_dir]
  
    obj:setVolumePitch(sfx_to_play, volume, 1)
    obj:playSFX(sfx_to_play)
  
    current_sfx_playing = sfx_to_play
end

--Code by Angelo234 end

local function moreVol()
	if volume <= 14 then
	volume = volume + 1
	gui.message("Radio Volume: " .. volume)

    obj:setVolumePitch(current_sfx_playing, volume, 1)
	end
	
	if volume >= 15 then
	gui.message("Max Radio Volume: " .. volume)

    obj:setVolumePitch(current_sfx_playing, volume, 1)
	end
end

local function lessVol()
	if volume >= 1 then
	volume = volume - 1
	gui.message("Radio Volume: " .. volume)

    obj:setVolumePitch(current_sfx_playing, volume, 1)
	end
	
	if volume == 0 then
	gui.message("Lowest Radio Volume: " .. volume)

    obj:setVolumePitch(current_sfx_playing, volume, 1)
	end
end


local function nextSong()
	if inputBlock == false then		--Blocking input for a small amount of time to prevent user from spamming the function and causing a lua error
		if song >= songLimit then
			song = 1
		else
			song = song + 1
		end
		
		if song ~=0 then
		playList()
		gui.message("Next song playing. Now playing: " .. songName .. " (" .. song .. "/" .. songLimit .. ")" .. " -by " .. author) 
		end	
	end
end

local function pastSong()
	if song ~=0 then
	song = song - 1
		if song == 0 then
			gui.message("Radio off")
			songName = "Radio Off"
			obj:stopSFX(current_sfx_playing)
		end
	end

	if song ~=0 then
	playList()
	gui.message("Past song playing. Now playing: " .. songName .. " (" .. song .. "/" .. songLimit .. ")" .. " -by " .. author) 
	end	
end

local function nextList()  
	if list >= listLimit then			
		list = 1
	else
		list = list + 1
	end 	
	
	song = 0
    if current_sfx_playing then
	obj:stopSFX(current_sfx_playing)
	end
	playList()
	gui.message("Next music list selected: " .. musicList .. " (" .. list .. "/" .. listLimit .. ")")
end
	
local function pastList()
	if list ~=1 then
	list = list - 1
	song = 0
    if current_sfx_playing then
	obj:stopSFX(current_sfx_playing)
	end
	playList()
	gui.message("Past music list selected: " .. musicList .. " (" .. list .. "/" .. listLimit .. ")")
	end
end

local function updateGFX(dt)
--Code by Angelo234 start
    if play_song_dir then
  
        --Check if we need to create SFX source
        if timer == 0 then
            need_to_create_sfx = loadSong(play_song_dir)
        end     
      
        --If needed to create SFX source
        --then start timer to delay playing song
        if need_to_create_sfx then
			inputBlock = true
            timer = timer + dt
        else
            timer = 0.1
			inputBlock = false
        end
  
        --If arbitrary amount of time passed then play song
        if timer >= 0.1 then
            playSong(play_song_dir)
            timer = 0
			inputBlock = false
            play_song_dir = nil
        end
    end
--Code by Angelo234 end
end

local function onInit()
 volume = 4
 song = 0
 list = 1
 timer = 0
 songName = "Radio Off"
 musicList = "Default Music"
 author = "Unknown"
 play_song_dir = nil
 inputBlock = false
 need_to_create_sfx = false
 current_sfx_playing = nil
 song_dir = nil
end

local function onReset()
 song = 0
 if current_sfx_playing then	--To disable all previously played music that stats playing upon reset for unknown reasons
	for i=1,songLimit do
		song = i
		playList()
		song_dir = play_song_dir
		if sfx_table[song_dir] == nil then break end	--loop exit for when no further music was loaded, preventing lua error
		obj:setVolumePitch(sfx_table[song_dir], 0, 1)
		obj:stopSFX(sfx_table[song_dir])
	end
 end
 song = 0
 list = 1
 timer = 0
 songName = "Radio Off"
 musicList = "Default Music"
 author = "Unknown"
 play_song_dir = nil
 inputBlock = false
 need_to_create_sfx = false
 current_sfx_playing = nil
 song_dir = nil
end

-- public interface
M.nextSong = nextSong
M.pastSong = pastSong
M.nextList = nextList
M.pastList = pastList
M.lessVol = lessVol
M.moreVol = moreVol
M.playList = playList
M.onInit    = onInit
M.onReset    = onReset
M.updateGFX = updateGFX
return M
